﻿// ************************** Script Information **************************
// TheMovieDB-Downloader V2.0.1
// (tested with Directory Opus 11.1b2)
// © 2010-2014 /^\\iran & steje
// 
// ****************************** Change log ******************************
// 2010-12-30 v0.5		Initial Release
// 2011-01-02 v0.5.1	Added URI encoding for MovieTitle
// 2011-01-28 v0.5.2	Utilized DOpus rename funktions to extract MovieName
// 2011-04-21 v0.5.2j	jscript release with error checking by steje
// 2011-09-11 v0.6		Added NotFoundFile generation
// 2013-10-14 v0.7		Update to MovieDB v3.0 JSON API, Added Info-File
// 2014-03-13 v2.0		Transformation to the new Dopus 11 Script Interface, Added Backdrop Download
// 2014-03-14 v2.0.1	Fixed wrong "\\" in Save Path
//
//
// ************************************************************************
// *                           System-Settings                            *
// ************************************************************************

// var MovieDB_APIKey, MovieDB_Language, MovieDB_PosterSize, MovieDB_PosterUrl, MovieDB_Url;
MovieDB_APIKey = "2cc30e3146b2f44d504561e96cfb358e";
MovieDB_BaseUrl = "https://api.themoviedb.org/3";


var LOG_DEBUG = 0;
var LOG_INFO = 1;
var LOG_WARN = 2;
var LOG_ERR = 3;
var LOG_ALERT = 4;
var LogLevel = LOG_WARN;

vecLogLevel = DOpus.NewVector
	vecLogLevel.push_back(2);
	vecLogLevel.push_back("DEBUG");
	vecLogLevel.push_back("INFO");
	vecLogLevel.push_back("WARNING");
	vecLogLevel.push_back("ERROR");
	vecLogLevel.push_back("ALERT");

MovieDB_PosterBaseUrl = ""
MovieDB_PosterPath = "";
MovieDB_BackdropPath = "";
MovieDB_OriginalTitle = "";
MovieDB_Collection = "";
MovieDB_ID = "";
MovieDB_Runtime = "";
MovieDB_Abstract = "";
MovieDB_Tagline = "";
MovieDB_ReleaseDate = "";
MovieDB_Genres = "";


// Called by Directory Opus to initialize the script
function OnInit(initData)
{
	// Provide basic information about the Script
	initData.name = "TheMovieDB.org Poster&Info Downloader";
	initData.desc = "Download Poster and Movie Infos from TheMovieDB.org.";
	initData.copyright = "© 2010-2014 /^\\iran & steje";
	initData.default_enable = true;

	// Base Configuration Parameters
	initData.config.NotFoundFileExtension = ".error";
	initData.config.InfoFileExtension = ".nfo";
	initData.config.BackdropSuffix = "-backdrop";

	initData.config.LogLevel = vecLogLevel;
	
	// Command initialisation
	var cmd = initData.AddCommand();
	cmd.name = "TheMovieDB-Downloader";
	cmd.method = "OnTheMovieDB";
	cmd.desc = initData.desc;
	cmd.label = "TheMovieDB.org Poster&Info Downloader";
	cmd.icon = "TheMovieDB:tmdb";
	cmd.template = "FILE/K,TITLEREGEXP/O/K,ERRFILE/O/S,INFOFILE/O/S,NOPOSTER/O/S,BACKDROP/O/S,POSTERSIZE/O[w2560,w1560,w1000,w684,w600,w370,w308,w184,w150,w90,h1264,w242_or_h262,w322_or_h336,w270_or_h398,w1416_or_h800,w704_or_h396,w600_or_h338,w2048_or_h1536,w2560_or_h1440,w384_or_h376,w554_or_h306,w184_or_h276,h1056,news_cdp_ipad,news_feed_ipad,news_detail_ipad,news_association_ipad,w121_or_h131,w161_or_h168,w135_or_h199,w708_or_h400,w300_or_h169,w1024_or_h768,w1280_or_h720,w192_or_h168,w272_or_h153,w92_or_h138,h528,w144_or_h118,w160_or_h168,w236,w120_or_h180,w960_or_h640,w256_or_h144,w88_or_h132,h552,w72_or_h69,w80_or_h84,w118,w60_or_h91,w352_or_h198,w480_or_h320,w96_or_h84,w128_or_h72,w44_or_h66,h276,original,w1920,w1280,w780,w500,w396,w376,w342,w300,w185,w154,w148,w130,w92,w75,w45,h632,square,max-square,pico-square,icon-square,thumb-square,medium-square,small-square,large-square,border,shadow,polaroid,emmy_overlay],BACKDROPSIZE/O[w2560,w1560,w1000,w684,w600,w370,w308,w184,w150,w90,h1264,w242_or_h262,w322_or_h336,w270_or_h398,w1416_or_h800,w704_or_h396,w600_or_h338,w2048_or_h1536,w2560_or_h1440,w384_or_h376,w554_or_h306,w184_or_h276,h1056,news_cdp_ipad,news_feed_ipad,news_detail_ipad,news_association_ipad,w121_or_h131,w161_or_h168,w135_or_h199,w708_or_h400,w300_or_h169,w1024_or_h768,w1280_or_h720,w192_or_h168,w272_or_h153,w92_or_h138,h528,w144_or_h118,w160_or_h168,w236,w120_or_h180,w960_or_h640,w256_or_h144,w88_or_h132,h552,w72_or_h69,w80_or_h84,w118,w60_or_h91,w352_or_h198,w480_or_h320,w96_or_h84,w128_or_h72,w44_or_h66,h276,original,w1920,w1280,w780,w500,w396,w376,w342,w300,w185,w154,w148,w130,w92,w75,w45,h632,square,max-square,pico-square,icon-square,thumb-square,medium-square,small-square,large-square,border,shadow,polaroid,emmy_overlay]";
            
	return false;
}

// About Dialog
function OnAboutScript(aboutData)
{
	About = "";
	About += "TheMovieDB.org Poster&Info Downloader V2.0.1\n";
	About += "March 14 2014\n\n";
	About += "© 2010-2014 /^\\iran & steje\n\n";
	About += "Feel free to use, optimize and enhance the script. Please post your comments and changes in the respective thread of the Dopus Resource Centre forum.\n";

	Commands = "";
	Commands += "*** Command Parameters ***\n";
	Commands += "\n";
	Commands += "FILE\n";
	Commands += "Filename of the Movie, should be the movie title at the same time. If you have a more complex filename you could use the regex parameter to extract the movie title.\n";
	Commands += "\n";
	Commands += "TITLEREGEXP\n";
	Commands += "Regular expression to extract the movie title from the filename. Movie Title must end in the $1 group.\n";
	Commands += "Default: (.*)\n";
	Commands += "\n";
	Commands += "ERRFILE\n";
	Commands += "Flag to create an error file, in case there are problems with themoviedb.org or the movie could not be found.\n";
	Commands += "Default: false\n";
	Commands += "\n";
	Commands += "INFOFILE\n";
	Commands += "Flag to create an info file, containing some additional information about the movie.\n";
	Commands += "Default: false\n";
	Commands += "\n";
	Commands += "NOPOSTER\n";
	Commands += "Flag to avoid the download of the movie poster. Usefull if you only want to get movie infos or the backdrop.\n";
	Commands += "Default: false\n";
	Commands += "\n";
	Commands += "BACKDROP\n";
	Commands += "Flag to download the movie backdrop image.\n";
	Commands += "Default: false\n";
	Commands += "\n";
	Commands += "POSTERSIZE\n";
	Commands += "Definition of the requested poster size according to themoviedb.org api.\n";
	Commands += "Default: original\n";
	Commands += "\n";
	Commands += "BACKDROPSIZE\n";
	Commands += "Definition of the requested poster size according to themoviedb.org api.\n";
	Commands += "Default: original\n";

	Config = "";
	Config += "*** Configuration Parameters ***\n";
	Config += "\n";
	Config += "LOGLEVEL\n";
	Config += "Defines the details of log information the script outputs to the dopus other log.\n";
	Config += "Default: WARNING\n";
	Config += "\n";
	Config += "NOTFOUNDFILEEXTENSION\n";
	Config += "File extension for the error file.\n";
	Config += "Default: .error\n";
	Config += "\n";
	Config += "INFOFILEEXTENSION\n";
	Config += "File extension for the movie info file.\n";
	Config += "Default: .nfo\n";
	Config += "\n";
	Config += "BACKDRIOSUFFIX\n";
	Config += "Suffix that will be added to the backdrop file name before the extension. \n";
	Config += "Default: -backdrop\n";

	// Create Dialog
	dlg = DOpus.Dlg;
	dlg.window = aboutData.window;
	dlg.title = "TheMovieDB.org Poster&Info Downloader";
	dlg.buttons = "About|Command Parameter|Config Parameter|Exit";
	dlg.icon = "info";
	
	ret = 1;
	do {
		if(ret == 1)	dlg.message = About;
		if(ret == 2)	dlg.message = Commands;
		if(ret == 3)	dlg.message = Config;
		ret = dlg.show;
	}
	while (ret != 0);
	return false;
}

function OnTheMovieDB(funcData)
{
	LogLevel = Script.config.LogLevel;	
	Logger (LOG_DEBUG, ("LogLevelName: " + vecLogLevel(LogLevel+1)));
	
	NotFoundFileExtension = Script.config.NotFoundFileExtension;
	Logger (LOG_DEBUG, ("NotFoundFileExtension: " + NotFoundFileExtension));

	InfoFileExtension = Script.config.InfoFileExtension;
	Logger (LOG_DEBUG, ("InfoFileExtension: " + InfoFileExtension));

	BackdropSuffix = Script.config.BackdropSuffix;
	Logger (LOG_DEBUG, ("BackdropSuffix: " + BackdropSuffix));

	File = "";
	if ( funcData.func.args.got_arg.file ) File = funcData.func.args.file;
	Logger (LOG_DEBUG, ("File: " + File));

	TitleRegExp = "(.*)";
	if ( funcData.func.args.got_arg.titleregexp ) TitleRegExp = funcData.func.args.titleregexp;
	Logger (LOG_DEBUG, ("TitleRegExp: " + TitleRegExp));

	ErrFile = false;
	if ( funcData.func.args.got_arg.ErrFile ) ErrFile = funcData.func.args.ErrFile;
	Logger (LOG_DEBUG, ("ErrFile: " + ErrFile));

	InfoFile = false;
	if ( funcData.func.args.got_arg.infofile ) InfoFile = funcData.func.args.infofile;
	Logger (LOG_DEBUG, ("InfoFile: " + InfoFile));

	NoPoster = false;
	if ( funcData.func.args.got_arg.NoPoster ) NoPoster = funcData.func.args.NoPoster;
	Logger (LOG_DEBUG, ("NoPoster: " + NoPoster));

	PosterSize = "original";
	if ( funcData.func.args.got_arg.PosterSize ) PosterSize = funcData.func.args.PosterSize.toLowerCase();
	Logger (LOG_DEBUG, ("PosterSize: " + PosterSize));

	Backdrop = false;
	if ( funcData.func.args.got_arg.Backdrop ) Backdrop = funcData.func.args.Backdrop;
	Logger (LOG_DEBUG, ("Backdrop: " + Backdrop));
	
	BackdropSize = "original";
	if ( funcData.func.args.got_arg.BackdropSize ) BackdropSize = funcData.func.args.BackdropSize.toLowerCase();
	Logger (LOG_DEBUG, ("BackdropSize: " + BackdropSize));
	
	filePath = File.replace(/(.*)\\(.*)\.(.*)$/, "$1\\");
	fileNameWoExt = File.replace(/(.*)\\(.*)\.(.*)$/, "$2");
	fileNameExt = File.replace(/(.*)\\(.*)\.(.*)$/, "\.$3");
	Logger (LOG_DEBUG, ("FilePath: " + filePath));
	Logger (LOG_DEBUG, ("FileNameWoExt: " + fileNameWoExt));
	Logger (LOG_DEBUG, ("FileNameExt: " + fileNameExt));
	
	MovieTitle = fileNameWoExt.replace(new RegExp(TitleRegExp), "$1");
	Logger (LOG_INFO, ("MovieTitle: " + MovieTitle));

	
// ************************************************************************
// *                             Functions                                *
// ************************************************************************


// Get Configuration (Images Base URL)
	var xhr = new ActiveXObject("Msxml2.XMLHTTP.6.0");
	url = MovieDB_BaseUrl + "/configuration?api_key=" + MovieDB_APIKey
	xhr.open("GET", url, false);
	xhr.setRequestHeader("Accept", "application/json");
	xhr.send(null)

	Logger (LOG_DEBUG, ("MovieDB Config Status: " + xhr.status));
	Logger (LOG_DEBUG, ("MovieDB Config: " + xhr.responseText));
	if(xhr.status != 200)
		{
			Logger (LOG_ALERT, "General failure getting response from MovieDB.org");
			if (ErrFile == true){saveErrorFile (MovieTitle, (FilePath + "\\" + fileNameWoExt + "." + NotFoundFileExtension));}
			return;
		}
	
	res = eval("(function(){return " + xhr.responseText+ ";})()");

	MovieDB_PosterBaseUrl = res.images.base_url
	Logger (LOG_DEBUG, ("MovieDB Images Base URL: " + MovieDB_PosterBaseUrl));

// Get Configuration (Images Base URL)
	url = MovieDB_BaseUrl + "/search/movie?api_key=" + MovieDB_APIKey + "&query=" + encodeURI(MovieTitle);
	Logger (LOG_DEBUG, "");
	Logger (LOG_DEBUG, ("MovieDB Poster Search Url: " + url));

	xhr.open("GET", url, false);
	xhr.setRequestHeader("Accept", "application/json");
	xhr.send(null)

	Logger (LOG_DEBUG, ("MovieDB Search Status: " + xhr.status));
	Logger (LOG_DEBUG, ("MovieDB Searchresult: " + xhr.responseText));
	if(xhr.status != 200)
		{
			Logger (LOG_ALERT, "General failure getting response from MovieDB.org");
			if (ErrFile == true){saveErrorFile (MovieTitle, (FilePath + "\\" + fileNameWoExt + "." + NotFoundFileExtension));}
			return;
		}
	res = eval("(function(){return " + xhr.responseText+ ";})()");
	if(res.total_results == 0)
		{
			Logger (LOG_ALERT, "No Movie found on MovieDB.org for: " + MovieTitle);
			if (ErrFile == true){saveErrorFile (MovieTitle, (filePath + "\\" + fileNameWoExt + "." + NotFoundFileExtension));}
			return;
		}
	
	MovieDB_PosterPath = res.results[0].poster_path;
	MovieDB_BackdropPath = res.results[0].backdrop_path;
	MovieDB_OriginalTitle = res.results[0].original_title;
	MovieDB_ID = res.results[0].id;

	Logger (LOG_INFO, ("MovieDB Original Title: " + MovieDB_OriginalTitle));
	
	url = MovieDB_PosterBaseUrl + PosterSize + MovieDB_PosterPath;
	Logger (LOG_DEBUG, ("MovieDB Poster Url: " + url));

	urlExtension = url.replace(/(.*)\.(.*)$/, "$2");
	if (NoPoster == false) saveFromUrl (url, (filePath +  fileNameWoExt + "." + urlExtension));

	url = MovieDB_PosterBaseUrl + BackdropSize + MovieDB_BackdropPath;
	Logger (LOG_DEBUG, ("MovieDB Backdrop Url: " + url));
	
	urlExtension = url.replace(/(.*)\.(.*)$/, "$2");
	if (Backdrop == true) saveFromUrl (url, (filePath + fileNameWoExt + BackdropSuffix +"." + urlExtension));
	
// ***********************************
// * Get Movie Infos
// *

	if (InfoFile != true){return}
	url = MovieDB_BaseUrl + "/movie/" + MovieDB_ID + "?api_key=" + MovieDB_APIKey;
	Logger (LOG_DEBUG, "");
	Logger (LOG_DEBUG, ("MovieDB Movie Url: " + url));

	xhr.open("GET", url, false);
	xhr.setRequestHeader("Accept", "application/json");
	xhr.send(null)

	Logger (LOG_DEBUG, ("MovieDB Movie Status: " + xhr.status));
	Logger (LOG_DEBUG, ("MovieDB Movie Result: " + xhr.responseText));
	if(xhr.status != 200)
		{
			Logger (LOG_ALERT, "General failure getting response from MovieDB.org");
			if (ErrFile == true){saveErrorFile (MovieTitle, (FilePath + "\\" + fileNameWoExt + "." + NotFoundFileExtension));}
			return;
		}
	res = eval("(function(){return " + xhr.responseText+ ";})()");

	if(res.belongs_to_collection != null){MovieDB_Collection = res.belongs_to_collection.name;}
	MovieDB_Runtime = res.runtime;
	MovieDB_Abstract = res.overview;
	MovieDB_Tagline = res.tagline;
	MovieDB_ReleaseDate = res.release_date;
	MovieDB_Genres = res.genres[0].name;
		for (var i = 1; i < res.genres.length; i++) {MovieDB_Genres += ", " + res.genres[i].name;}

// Save Info File
	saveInfoFile (MovieTitle, (filePath + fileNameWoExt + InfoFileExtension));
}

function saveFromUrl(Url, File)
{
	Logger (LOG_DEBUG, ("MovieDB Poster Local File: " + File));
	var oxmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
	oxmlhttp.open("GET",Url,false);
	oxmlhttp.send(null);

	var ostream = new ActiveXObject("ADODB.Stream");
	ostream.type=1;		//binary
	ostream.mode=3;		//read-write
	ostream.open;
	ostream.write(oxmlhttp.responsebody);
	ostream.savetofile(File,2);		//save-create-overwrite
	ostream.close;
}

function saveErrorFile(MovieTitle, File)
{
	var ostream = new ActiveXObject("ADODB.Stream");
	ostream.type=2;		//binary
	ostream.mode=3;		//read-write
	ostream.open;
	ostream.writeText(MovieTitle + " not found");
	ostream.savetofile(File,2);		//save-create-overwrite
	ostream.close;
}

function saveInfoFile(MovieTitle, File)
{
	var ostream = new ActiveXObject("ADODB.Stream");
	ostream.type=2;		//binary
	ostream.mode=3;		//read-write
	ostream.open;

	ostream.writeText("Title:         " + MovieTitle + "\n");
	ostream.writeText("Collection:    " + MovieDB_Collection + "\n");
	ostream.writeText("Original Title:" + MovieDB_OriginalTitle + "\n");
	ostream.writeText("theMovieDB-ID: " + MovieDB_ID + "\n");
	ostream.writeText("Release Date:  " + MovieDB_ReleaseDate + "\n");
	ostream.writeText("Runtime:       " + MovieDB_Runtime + "\n");
	ostream.writeText("Genres:        " + MovieDB_Genres + "\n");
	ostream.writeText("Tagline:       " + MovieDB_Tagline + "\n");
	ostream.writeText("Overview:      " + MovieDB_Abstract + "\n");

	ostream.savetofile(File,2);		//save-create-overwrite
	ostream.close;
}

function Logger(Level, strMessage)
{
	if (Level>=LogLevel)
	{
		DOpus.OutputString("   " + strMessage);		
	}
}
